program ab
  use sep
  integer :: n1,n2,n3,i1,i2,i,n4,i4,i3
  real :: o1,o2,d1,d2,mymax,out(50,50,50),o3,d3
  real, allocatable :: in(:,:,:)

  call sep_init() 
  call from_history("n1",n1)
  call from_history("n3",n3)
  call from_history("n2",n2)
  call from_history("n4",n4,1)


  allocate(in(3,n3*n2,n4))
  call sreed("in",in,size(in)*4)

  o1=minval(in(1,:,:))
  mymax=maxval(in(1,:,:))
  d1=(mymax-o1)/49.

  o2=minval(in(2,:,:))
  mymax=maxval(in(2,:,:))
  d2=(mymax-o2)/49.

  o3=minval(in(3,:,:))
  mymax=maxval(in(3,:,:))
  d3=(mymax-o3)/49.


  call sep_put_data_axis_par("out",1,50,o1,d1,"par1")
  call sep_put_data_axis_par("out",2,50,o2,d2,"par2")
  call sep_put_data_axis_par("out",3,50,o3,d3,"par3")

  do i4=1,n4
  out=0.
  do i=1,n3*n2
    i1=max(1,min(50,nint((in(1,i,i4)-o1)/d1+1.)))
    i2=max(1,min(50,nint((in(2,i,i4)-o2)/d2+1.)))
    i3=max(1,min(50,nint((in(3,i,i4)-o3)/d3+1.)))
    out(i1,i2,i3)=1+out(i1,i2,i3)
  end do
 call srite('out',out,50*50*50*4)
end do
  
end program
